
/*
 * This file was generated by the SOM Compiler.
 * FileName: BlackHol.c.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter emitc: 1.24
 */

/*Ŀ
  Greg's Black Hole - anything you put in will disappear forever...  
                      This version resolves folder structure         
                      and reset Read only attribute... Dangerous !   
                      Gregory Czaja, 71052,720        November 1992  
  will allow removing desktop, if not the current one December 1992  
*/


#define BlackHole_Class_Source
#include "BlackHol.ih"
#include <wpObject.h>
#include <wpFolder.h>
#include <wpDesk.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

void MyFreeDraginfo(PDRAGINFO pdrgInfo);
void ResolveAndDelete(WPObject * pWPObject);

SOM_Scope MRESULT   SOMLINK BlackHolX_wpDragOver(BlackHole *somSelf,
                HWND hwndCnr,
                PDRAGINFO pdrgInfo)
{
    ULONG ulItemCnt=0;
    ULONG ulItem=0;
    USHORT usDropIndic=DOR_DROP;
    BlackHoleData *somThis = BlackHoleGetData(somSelf);
    BlackHoleMethodDebug("BlackHole","BlackHolX_wpDragOver");

          /* Check that items are workplace shell objects */

      ulItemCnt=DrgQueryDragitemCount(pdrgInfo);
      for(ulItem=0;ulItem<ulItemCnt;ulItem++) {
       DRAGITEM DItem;

        DrgQueryDragitem(pdrgInfo,sizeof(DItem),&DItem,ulItem);

                      /* check that it is a WPS object RMF */
        if(!DrgVerifyRMF(&DItem,"DRM_OBJECT","DRF_OBJECT")) {
                      /* if it's not - don't accept !      */
          usDropIndic=DOR_NEVERDROP;
        }/* end if */
      }/* end for */

                    /* Free the draginfo if not same process */
      MyFreeDraginfo(pdrgInfo);

      return (MRFROM2SHORT(usDropIndic,DO_UNKNOWN));
      /*
      return (parent_wpDragOver(somSelf,hwndCnr,pdrgInfo));
       */
}

SOM_Scope MRESULT   SOMLINK BlackHolX_wpDrop(BlackHole *somSelf,
                HWND hwndCnr,
                PDRAGINFO pdrgInfo,
                PDRAGITEM pdrgItem)
{
    WPObject *pWPObjDropped;
    PSZ   message =malloc(256);
    PSZ   object;
    PSZ   pszClass;

    BlackHoleData *somThis = BlackHoleGetData(somSelf);
    BlackHoleMethodDebug("BlackHole","BlackHolX_wpDrop");

    pWPObjDropped=OBJECT_FROM_PREC(pdrgItem->ulItemID);
    object       =_wpQueryTitle(pWPObjDropped);
    pszClass     =(PSZ)_somGetClassName(pWPObjDropped);

    strcpy(message, "You are about to delete: ");
    strcat(message, object);
    strcat(message, " including the entire content, if any.");
    strcat(message, " Push \"Yes\" to confirm, \"No\" to cancel !");
    if (MBID_YES == WinMessageBox(HWND_DESKTOP,
                                  HWND_DESKTOP,
                                  message,
                                 "Black Hole - destroy object",
                                  0,
                                  MB_YESNO | MB_DEFBUTTON2 | MB_WARNING | MB_SYSTEMMODAL )){
                                  /* wants a VERY special delete ??? */
       if (strcmp(pszClass, "WPDesktop") == 0) {
                                  /* is this the current desktop ? */
          if (_wpIsCurrentDesktop(pWPObjDropped)) {
             WinMessageBox(HWND_DESKTOP,
                           HWND_DESKTOP,
                           "You must be joking... \
                           Do you realy want to delete your Desktop ?",
                           "DeskMan/2 - destroy object",
                           0,
                           MB_CANCEL | MB_WARNING | MB_SYSTEMMODAL );
          } else {
            if (MBID_YES == WinMessageBox(HWND_DESKTOP,
                                          HWND_DESKTOP,
                                          "Deleting an inactive Desktop may cause\
                                          problems on some systems.\
                                          Objects on the active Desktop may be damaged.\
                                          Do you want to continue ?",
                                          "DeskMan/2 - Destroy object",
                                          0,
                                          MB_YESNO | MB_DEFBUTTON2 | MB_WARNING | MB_SYSTEMMODAL )){
               ResolveAndDelete(pWPObjDropped);
            };
          } /* endif */
       } else {
          ResolveAndDelete(pWPObjDropped);
       } /* endif */
    };
    free(message);

    return (parent_wpDrop(somSelf,hwndCnr,pdrgInfo,pdrgItem));
}

#undef SOM_CurrentClass
#define SOM_CurrentClass SOMMeta
SOM_Scope void   SOMLINK BlackHolC_wpclsInitData(M_BlackHole *somSelf)
{
    /* M_BlackHoleData *somThis = M_BlackHoleGetData(somSelf); */
    M_BlackHoleMethodDebug("M_BlackHole","BlackHolC_wpclsInitData");

    parent_wpclsInitData(somSelf);
}

SOM_Scope void   SOMLINK BlackHolC_wpclsUnInitData(M_BlackHole *somSelf)
{
    /* M_BlackHoleData *somThis = M_BlackHoleGetData(somSelf); */
    M_BlackHoleMethodDebug("M_BlackHole","BlackHolC_wpclsUnInitData");

    parent_wpclsUnInitData(somSelf);
}

/*  ORDINARY CODE SECTION  Ŀ
****                                                                     ****
****                  Any non-method code should go here.                ****
****                                                                     ****
*/
#undef SOM_CurrentClass

/*Ŀ
 ResolveAndDelete                                                          
 Purpose: resolves composite objects and deletes atomic ones...            
*/
VOID ResolveAndDelete(WPObject * pWPObject)
{ 
   ULONG ulFlags;

   PSZ   message =malloc(256);
   PSZ pszObject =_wpQueryTitle(pWPObject);
   PSZ pszClass  =(PSZ)_somGetClassName(pWPObject);
                                    /* those are represented by real files... */
   if (strcmp(pszClass,"WPFileSystem")==0   |
       strcmp(pszClass,"WPDataFile")==0     |
       strcmp(pszClass,"WPFolder")==0       |
       strcmp(pszClass,"WPProgramGroup")==0 |
       strcmp(pszClass,"WPProgramFile")==0  |
       strcmp(pszClass,"WPTemplateFolder")==0 ) {
                                    /* get the object's file Attributes... */
      ulFlags=_wpQueryAttr(pWPObject);
                                    /* now reset the read only bit */
      _wpSetAttr(pWPObject, ulFlags & ~FILE_READONLY);

   } /* endif */
                                    /* resolve composite objects if necessary */
   if (strcmp(pszClass,"WPFolder")==0         |
       strcmp(pszClass,"WPTemplateFolder")==0 |
       strcmp(pszClass,"WPProgramGroup")==0   ){

       PSZ pszFilename=NULL;
       ULONG  pcb;
                                     /* get the real name for populate */
       if _wpQueryRealName(pWPObject,NULL,&pcb,TRUE){
          pszFilename=malloc(pcb+2);            /* get the buffer */
          memset(pszFilename,'\0',pcb+1);
          _wpQueryRealName(pWPObject,pszFilename,&pcb,TRUE);
       } /* endif */
       if (_wpPopulate(pWPObject, 0L, pszFilename, FALSE)) {
          WPObject * pWPObjectTemp;
                      /* go through folder's content   */
          for(pWPObjectTemp=_wpQueryContent(pWPObject,pWPObjectTemp,QC_First);
              pWPObjectTemp != NULL;
              pWPObjectTemp=_wpQueryContent(pWPObject,pWPObjectTemp,QC_Next)) {
 
              ResolveAndDelete(pWPObjectTemp);
          }/* end for */
       } /* endif */
       if (pszFilename != NULL) 
          free(pszFilename);
   } /* endif */
                                       /* now reset the noDelete style */
   _wpSetStyle(pWPObject, !OBJSTYLE_NODELETE);
   if ( _wpDelete(pWPObject, 0) != OK_DELETE ) {
      strcpy(message, "Object: ");
      strcat(message, pszObject);
      strcat(message, " could not be deleted !");
      WinMessageBox(HWND_DESKTOP,
                    HWND_DESKTOP,
                    message,
                    "Black Hole - destroy object",
                    0,
                    MB_CANCEL | MB_WARNING | MB_SYSTEMMODAL );
   };
  free(message);
  return;
}
/*Ŀ
 MyFreeDraginfo()        courtesy of Ph. Gregoire                          
 Purpose: Frees the drag info if not same process                          
*/
void MyFreeDraginfo(PDRAGINFO pdrgInfo)
{PID pidSrc;
 TID tidSrc;
 PTIB ptib;
 PPIB ppib;

  WinQueryWindowProcess(pdrgInfo->hwndSource,&pidSrc,&tidSrc);
  DosGetInfoBlocks(&ptib,&ppib);

  if(ppib->pib_ulpid!=pidSrc) {
    DrgFreeDraginfo(pdrgInfo);
  }/* end if */

}/* end MyFreeDraginfo */

